OGRE-Next: Ogre::Vector3 Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Vector3 Class Reference
Core » Math

Standard 3-dimensional vector. More...

`#include <OgreVector3.h>`

## Public Member Functions
| Vector3 ()
| Default constructor.
| Vector3 (const int afCoordinate[3])
| Vector3 (const Real afCoordinate[3])
| Vector3 (const Real fX, const Real fY, const Real fZ)
| Vector3 (const Real scaler)
| Vector3 (Real *const r)
Real | absDotProduct (const Vector3 &vec) const
| Calculates the absolute dot (scalar) product of this vector with another.
Radian | angleBetween (const Vector3 &dest) const
| Gets the angle between 2 vectors.
Real | collapseMax () const
| Returns the maximum value of all components.
Real | collapseMin () const
| Returns the minimum value of all components.
Vector3 | crossProduct (const Vector3 &rkVector) const
| Calculates the cross-product of 2 vectors, i.e.
bool | directionEquals (const Vector3 &rhs, const Radian &tolerance) const
| Returns whether this vector is within a directional tolerance of another vector.
Real | distance (const Vector3 &rhs) const
| Returns the distance to another vector.
Real | dotProduct (const Vector3 &vec) const
| Calculates the dot (scalar) product of this vector with another.
Quaternion | getRotationTo (const Vector3 &dest, const Vector3 &fallbackAxis=Vector3::ZERO) const
| Gets the shortest arc quaternion to rotate this vector to the destination vector.
bool | isNaN () const
| Check whether this vector contains valid values.
bool | isZeroLength () const
| Returns true if this vector is zero length.
Real | length () const
| Returns the length (magnitude) of the vector.
void | makeAbs ()
| Causes negative members to become positive.
void | makeCeil (const Vector3 &cmp)
| Sets this vector's components to the maximum of its own and the ones of the passed in vector.
void | makeFloor (const Vector3 &cmp)
| Sets this vector's components to the minimum of its own and the ones of the passed in vector.
Vector3 | midPoint (const Vector3 &vec) const
| Returns a vector at a point half way between this and the passed in vector.
Real | normalise ()
| Normalises the vector.
Vector3 | normalisedCopy () const
| As normalise, except that this vector is unaffected and the normalised vector is returned as a copy.
bool | operator!= (const Vector3 &rkVector) const
Vector3 | operator* (const Real fScalar) const
Vector3 | operator* (const Vector3 &rhs) const
Vector3 & | operator*= (const Real fScalar)
Vector3 & | operator*= (const Vector3 &rkVector)
const Vector3 & | operator+ () const
Vector3 | operator+ (const Vector3 &rkVector) const
Vector3 & | operator+= (const Real fScalar)
Vector3 & | operator+= (const Vector3 &rkVector)
Vector3 | operator- () const
Vector3 | operator- (const Vector3 &rkVector) const
Vector3 & | operator-= (const Real fScalar)
Vector3 & | operator-= (const Vector3 &rkVector)
Vector3 | operator/ (const Real fScalar) const
Vector3 | operator/ (const Vector3 &rhs) const
Vector3 & | operator/= (const Real fScalar)
Vector3 & | operator/= (const Vector3 &rkVector)
bool | operator< (const Vector3 &rhs) const
| Returns true if the vector's scalar components are all greater that the ones of the vector it is compared against.
Vector3 & | operator= (const Real fScaler)
bool | operator== (const Vector3 &rkVector) const
bool | operator> (const Vector3 &rhs) const
| Returns true if the vector's scalar components are all smaller that the ones of the vector it is compared against.
Real & | operator[] (const size_t i)
Real | operator[] (const size_t i) const
Vector3 | perpendicular () const
| Generates a vector perpendicular to this vector (eg an 'up' vector).
bool | positionCloses (const Vector3 &rhs, Real tolerance=1e-03f) const
| Returns whether this vector is within a positional tolerance of another vector, also take scale of the vectors into account.
bool | positionEquals (const Vector3 &rhs, Real tolerance=Real(1e-03)) const
| Returns whether this vector is within a positional tolerance of another vector.
Vector3 | primaryAxis () const
| Extract the primary (dominant) axis from this direction vector.
Real * | ptr ()
| Pointer accessor for direct copying.
const Real * | ptr () const
| Pointer accessor for direct copying.
Vector3 | randomDeviant (const Radian &angle, const Vector3 &up=Vector3::ZERO) const
| Generates a new random vector which deviates from this vector by a given angle in a random direction.
Vector3 | reflect (const Vector3 &normal) const
| Calculates a reflection vector to the plane with the given normal .
Real | squaredDistance (const Vector3 &rhs) const
| Returns the square of the distance to another vector.
Real | squaredLength () const
| Returns the square of the length(magnitude) of the vector.
void | swap (Vector3 &other)
| Exchange the contents of this vector with another.
Vector2 | xy () const
| Swizzle-like narrowing operations.

## Public Attributes
Real | x
Real | y
Real | z

## Static Public Attributes
static const Vector3 | NEGATIVE_UNIT_X
static const Vector3 | NEGATIVE_UNIT_Y
static const Vector3 | NEGATIVE_UNIT_Z
static const Vector3 | UNIT_SCALE
static const Vector3 | UNIT_X
static const Vector3 | UNIT_Y
static const Vector3 | UNIT_Z
static const Vector3 | ZERO

## Detailed Description

Standard 3-dimensional vector.

Remarks
  A direction in 3D space represented as distances along the 3 orthogonal axes (x, y, z). Note that positions, directions and scaling factors can be represented by a vector, depending on how you interpret the values.

## Constructor & Destructor Documentation

## ◆ Vector3() [1/6]

Ogre::Vector3::Vector3 | ( |  | ) |
| inline

Default constructor.

Note
  It does NOT initialize the vector for efficiency.

Referenced by absDotProduct(), angleBetween(), crossProduct(), directionEquals(), distance(), dotProduct(), getRotationTo(), makeCeil(), makeFloor(), midPoint(), normalisedCopy(), operator!=(), operator*(), operator*, operator*(), operator*=(), operator*=(), operator+(), operator+, operator+, operator+(), operator+=(), operator+=(), operator-(), operator-, operator-, operator-(), operator-=(), operator-=(), operator/(), operator/, operator/(), operator/=(), operator/=(), operator<(), operator<<, operator=(), operator==(), operator>(), perpendicular(), positionCloses(), positionEquals(), primaryAxis(), randomDeviant(), reflect(), squaredDistance(), and swap().

## ◆ Vector3() [2/6]

Ogre::Vector3::Vector3 | ( | const Real | fX,
|  | const Real | fY,
|  | const Real | fZ )
| inline

References x, y, and z.

## ◆ Vector3() [3/6]

Ogre::Vector3::Vector3 | ( | const Real | afCoordinate[3] | ) |
| inlineexplicit

References x, y, and z.

## ◆ Vector3() [4/6]

Ogre::Vector3::Vector3 | ( | const int | afCoordinate[3] | ) |
| inlineexplicit

References x, y, and z.

## ◆ Vector3() [5/6]

Ogre::Vector3::Vector3 | ( | Real *const | r | ) |
| inlineexplicit

References x, y, and z.

## ◆ Vector3() [6/6]

Ogre::Vector3::Vector3 | ( | const Real | scaler | ) |
| inlineexplicit

References x, y, and z.

## Member Function Documentation

## ◆ absDotProduct()

Real Ogre::Vector3::absDotProduct | ( | const Vector3 & | vec | ) | const
| inline

Calculates the absolute dot (scalar) product of this vector with another.

Remarks
  This function work similar dotProduct, except it use absolute value of each component of the vector to computing.

Parameters

  vec | Vector with which to calculate the absolute dot product (together with this one).

Returns
  A Real representing the absolute dot product value.

References Vector3(), Ogre::Math::Abs(), x, y, and z.

## ◆ angleBetween()

Radian Ogre::Vector3::angleBetween | ( | const Vector3 & | dest | ) | const
| inline

Gets the angle between 2 vectors.

Remarks
  Vectors do not have to be unit-length but must represent directions.

References Vector3(), Ogre::Math::ACos(), Ogre::Math::Clamp(), dotProduct(), and length().

## ◆ collapseMax()

Real Ogre::Vector3::collapseMax | ( |  | ) | const
| inline

Returns the maximum value of all components.

References x, y, and z.

## ◆ collapseMin()

Real Ogre::Vector3::collapseMin | ( |  | ) | const
| inline

Returns the minimum value of all components.

References x, y, and z.

## ◆ crossProduct()

Vector3 Ogre::Vector3::crossProduct | ( | const Vector3 & | rkVector | ) | const
| inline

Calculates the cross-product of 2 vectors, i.e.

the vector that lies perpendicular to them both.

Remarks
  The cross-product is normally used to calculate the normal vector of a plane, by calculating the cross-product of 2 non-equivalent vectors which lie on the plane (e.g. 2 edges of a triangle).

Parameters

  rkVector | Vector which, together with this one, will be used to calculate the cross-product.

Returns
  A vector which is the result of the cross-product. This vector will NOT be normalised, to maximise efficiency
  - call Vector3::normalise on the result if you wish this to be done. As for which side the resultant vector will be on, the returned vector will be on the side from which the arc from 'this' to rkVector is anticlockwise, e.g. UNIT_Y.crossProduct(UNIT_Z) = UNIT_X, whilst UNIT_Z.crossProduct(UNIT_Y) = -UNIT_X. This is because OGRE uses a right-handed coordinate system.

  For a clearer explanation, look a the left and the bottom edges of your monitor's screen. Assume that the first vector is the left edge and the second vector is the bottom edge, both of them starting from the lower-left corner of the screen. The resulting vector is going to be perpendicular to both of them and will go inside the screen, towards the cathode tube (assuming you're using a CRT monitor, of course).

References Vector3(), x, y, and z.

Referenced by getRotationTo(), and perpendicular().

## ◆ directionEquals()

bool Ogre::Vector3::directionEquals | ( | const Vector3 & | rhs,
|  | const Radian & | tolerance ) const
| inline

Returns whether this vector is within a directional tolerance of another vector.

Parameters

  rhs | The vector to compare with
  tolerance | The maximum angle by which the vectors may vary and still be considered equal

Note
  Both vectors should be normalised.

References Vector3(), Ogre::Math::Abs(), Ogre::Math::ACos(), dotProduct(), and Ogre::Radian::valueRadians().

## ◆ distance()

Real Ogre::Vector3::distance | ( | const Vector3 & | rhs | ) | const
| inline

Returns the distance to another vector.

Warning
  This operation requires a square root and is expensive in terms of CPU operations. If you don't need to know the exact distance (e.g. for just comparing distances) use squaredDistance() instead.

References Vector3().

## ◆ dotProduct()

Real Ogre::Vector3::dotProduct | ( | const Vector3 & | vec | ) | const
| inline

Calculates the dot (scalar) product of this vector with another.

Remarks
  The dot product can be used to calculate the angle between 2 vectors. If both are unit vectors, the dot product is the cosine of the angle; otherwise the dot product must be divided by the product of the lengths of both vectors to get the cosine of the angle. This result can further be used to calculate the distance of a point from a plane.

Parameters

  vec | Vector with which to calculate the dot product (together with this one).

Returns
  A float representing the dot product value.

References Vector3(), x, y, and z.

Referenced by angleBetween(), directionEquals(), getRotationTo(), Ogre::Plane::redefine(), and reflect().

## ◆ getRotationTo()

Quaternion Ogre::Vector3::getRotationTo | ( | const Vector3 & | dest,
|  | const Vector3 & | fallbackAxis = Vector3::ZERO ) const
| inline

Gets the shortest arc quaternion to rotate this vector to the destination vector.

Remarks
  If you call this with a dest vector that is close to the inverse of this vector, we will rotate 180 degrees around the 'fallbackAxis' (if specified, or a generated axis if not) since in this case ANY axis of rotation is valid.

References Vector3(), crossProduct(), dotProduct(), Ogre::Quaternion::FromAngleAxis(), Ogre::Quaternion::IDENTITY, isZeroLength(), Ogre::Quaternion::normalise(), normalise(), Ogre::Math::PI, Ogre::Math::Sqrt(), UNIT_X, UNIT_Y, Ogre::Quaternion::w, Ogre::Quaternion::x, x, Ogre::Quaternion::y, y, Ogre::Quaternion::z, z, and ZERO.

## ◆ isNaN()

bool Ogre::Vector3::isNaN | ( |  | ) | const
| inline

Check whether this vector contains valid values.

References Ogre::Math::isNaN(), x, y, and z.

## ◆ isZeroLength()

bool Ogre::Vector3::isZeroLength | ( |  | ) | const
| inline

Returns true if this vector is zero length.

References x, y, and z.

Referenced by getRotationTo().

## ◆ length()

Real Ogre::Vector3::length | ( |  | ) | const
| inline

Returns the length (magnitude) of the vector.

Warning
  This operation requires a square root and is expensive in terms of CPU operations. If you don't need to know the exact length (e.g. for just comparing lengths) use squaredLength() instead.

References Ogre::Math::Sqrt(), x, y, and z.

Referenced by angleBetween().

## ◆ makeAbs()

void Ogre::Vector3::makeAbs | ( |  | ) |
| inline

Causes negative members to become positive.

References Ogre::Math::Abs(), x, y, and z.

## ◆ makeCeil()

void Ogre::Vector3::makeCeil | ( | const Vector3 & | cmp | ) |
| inline

Sets this vector's components to the maximum of its own and the ones of the passed in vector.

Remarks
  'Maximum' in this case means the combination of the highest value of x, y and z from both vectors. Highest is taken just numerically, not magnitude, so 1 > -3.

References Vector3(), x, y, and z.

Referenced by Ogre::AxisAlignedBox::intersection(), and Ogre::AxisAlignedBox::merge().

## ◆ makeFloor()

void Ogre::Vector3::makeFloor | ( | const Vector3 & | cmp | ) |
| inline

Sets this vector's components to the minimum of its own and the ones of the passed in vector.

Remarks
  'Minimum' in this case means the combination of the lowest value of x, y and z from both vectors. Lowest is taken just numerically, not magnitude, so -1 < 0.

References Vector3(), x, y, and z.

Referenced by Ogre::AxisAlignedBox::intersection(), and Ogre::AxisAlignedBox::merge().

## ◆ midPoint()

Vector3 Ogre::Vector3::midPoint | ( | const Vector3 & | vec | ) | const
| inline

Returns a vector at a point half way between this and the passed in vector.

References Vector3(), x, y, and z.

## ◆ normalise()

Real Ogre::Vector3::normalise | ( |  | ) |
| inline

Normalises the vector.

Remarks
  This method normalises the vector such that it's length / magnitude is 1. The result is called a unit vector.

Note
  This function will not crash for zero-sized vectors, but there will be no changes made to their components.

Returns
  The previous length of the vector.

References Ogre::Math::Sqrt(), x, y, and z.

Referenced by getRotationTo(), normalisedCopy(), Ogre::Matrix4::operator*(), and perpendicular().

## ◆ normalisedCopy()

Vector3 Ogre::Vector3::normalisedCopy | ( |  | ) | const
| inline

As normalise, except that this vector is unaffected and the normalised vector is returned as a copy.

References Vector3(), and normalise().

## ◆ operator!=()

bool Ogre::Vector3::operator!= | ( | const Vector3 & | rkVector | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator*() [1/2]

Vector3 Ogre::Vector3::operator* | ( | const Real | fScalar | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator*() [2/2]

Vector3 Ogre::Vector3::operator* | ( | const Vector3 & | rhs | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator*=() [1/2]

Vector3 & Ogre::Vector3::operator*= | ( | const Real | fScalar | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator*=() [2/2]

Vector3 & Ogre::Vector3::operator*= | ( | const Vector3 & | rkVector | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator+() [1/2]

const Vector3 & Ogre::Vector3::operator+ | ( |  | ) | const
| inline

References Vector3().

## ◆ operator+() [2/2]

Vector3 Ogre::Vector3::operator+ | ( | const Vector3 & | rkVector | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator+=() [1/2]

Vector3 & Ogre::Vector3::operator+= | ( | const Real | fScalar | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator+=() [2/2]

Vector3 & Ogre::Vector3::operator+= | ( | const Vector3 & | rkVector | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator-() [1/2]

Vector3 Ogre::Vector3::operator- | ( |  | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator-() [2/2]

Vector3 Ogre::Vector3::operator- | ( | const Vector3 & | rkVector | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator-=() [1/2]

Vector3 & Ogre::Vector3::operator-= | ( | const Real | fScalar | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator-=() [2/2]

Vector3 & Ogre::Vector3::operator-= | ( | const Vector3 & | rkVector | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator/() [1/2]

Vector3 Ogre::Vector3::operator/ | ( | const Real | fScalar | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator/() [2/2]

Vector3 Ogre::Vector3::operator/ | ( | const Vector3 & | rhs | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator/=() [1/2]

Vector3 & Ogre::Vector3::operator/= | ( | const Real | fScalar | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator/=() [2/2]

Vector3 & Ogre::Vector3::operator/= | ( | const Vector3 & | rkVector | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator<()

bool Ogre::Vector3::operator< | ( | const Vector3 & | rhs | ) | const
| inline

Returns true if the vector's scalar components are all greater that the ones of the vector it is compared against.

References Vector3(), x, y, and z.

## ◆ operator=()

Vector3 & Ogre::Vector3::operator= | ( | const Real | fScaler | ) |
| inline

References Vector3(), x, y, and z.

## ◆ operator==()

bool Ogre::Vector3::operator== | ( | const Vector3 & | rkVector | ) | const
| inline

References Vector3(), x, y, and z.

## ◆ operator>()

bool Ogre::Vector3::operator> | ( | const Vector3 & | rhs | ) | const
| inline

Returns true if the vector's scalar components are all smaller that the ones of the vector it is compared against.

References Vector3(), x, y, and z.

## ◆ operator[]() [1/2]

Real & Ogre::Vector3::operator[] | ( | const size_t | i | ) |
| inline

References x.

## ◆ operator[]() [2/2]

Real Ogre::Vector3::operator[] | ( | const size_t | i | ) | const
| inline

References x.

## ◆ perpendicular()

Vector3 Ogre::Vector3::perpendicular | ( |  | ) | const
| inline

Generates a vector perpendicular to this vector (eg an 'up' vector).

Remarks
  This method will return a vector which is perpendicular to this vector. There are an infinite number of possibilities but this method will guarantee to generate one of them. If you need more control you should use the Quaternion class.

References Vector3(), crossProduct(), normalise(), squaredLength(), UNIT_X, and UNIT_Y.

Referenced by randomDeviant().

## ◆ positionCloses()

bool Ogre::Vector3::positionCloses | ( | const Vector3 & | rhs,
|  | Real | tolerance = 1e-03f ) const
| inline

Returns whether this vector is within a positional tolerance of another vector, also take scale of the vectors into account.

Parameters

  rhs | The vector to compare with
  tolerance | The amount (related to the scale of vectors) that distance of the vector may vary by and still be considered close

References Vector3(), squaredDistance(), and squaredLength().

## ◆ positionEquals()

bool Ogre::Vector3::positionEquals | ( | const Vector3 & | rhs,
|  | Real | tolerance = Real( 1e-03 ) ) const
| inline

Returns whether this vector is within a positional tolerance of another vector.

Parameters

  rhs | The vector to compare with
  tolerance | The amount that each element of the vector may vary by and still be considered equal

References Vector3(), Ogre::Math::RealEqual(), x, y, and z.

## ◆ primaryAxis()

Vector3 Ogre::Vector3::primaryAxis | ( |  | ) | const
| inline

Extract the primary (dominant) axis from this direction vector.

References Vector3(), Ogre::Math::Abs(), NEGATIVE_UNIT_X, NEGATIVE_UNIT_Y, NEGATIVE_UNIT_Z, UNIT_X, UNIT_Y, UNIT_Z, x, y, and z.

## ◆ ptr() [1/2]

Real * Ogre::Vector3::ptr | ( |  | ) |
| inline

Pointer accessor for direct copying.

References x.

## ◆ ptr() [2/2]

const Real * Ogre::Vector3::ptr | ( |  | ) | const
| inline

Pointer accessor for direct copying.

References x.

## ◆ randomDeviant()

Vector3 Ogre::Vector3::randomDeviant | ( | const Radian & | angle,
|  | const Vector3 & | up = Vector3::ZERO ) const
| inline

Generates a new random vector which deviates from this vector by a given angle in a random direction.

Remarks
  This method assumes that the random number generator has already been seeded appropriately.

Parameters

  angle | The angle at which to deviate
  up | Any vector perpendicular to this one (which could generated by cross-product of this vector and any other non-colinear vector). If you choose not to provide this the function will derive one on it's own, however if you provide one yourself the function will be faster (this allows you to reuse up vectors if you call this method more than once)

Returns
  A random vector which deviates from this vector by angle. This vector will not be normalised, normalise it if you wish afterwards.

References Vector3(), Ogre::Quaternion::FromAngleAxis(), perpendicular(), Ogre::Math::TWO_PI, Ogre::Math::UnitRandom(), and ZERO.

## ◆ reflect()

Vector3 Ogre::Vector3::reflect | ( | const Vector3 & | normal | ) | const
| inline

Calculates a reflection vector to the plane with the given normal .

Remarks
  NB assumes 'this' is pointing AWAY FROM the plane, invert if it is not.

References Vector3(), and dotProduct().

## ◆ squaredDistance()

Real Ogre::Vector3::squaredDistance | ( | const Vector3 & | rhs | ) | const
| inline

Returns the square of the distance to another vector.

Remarks
  This method is for efficiency - calculating the actual distance to another vector requires a square root, which is expensive in terms of the operations required. This method returns the square of the distance to another vector, i.e. the same as the distance but before the square root is taken. Use this if you want to find the longest / shortest distance without incurring the square root.

References Vector3().

Referenced by positionCloses().

## ◆ squaredLength()

Real Ogre::Vector3::squaredLength | ( |  | ) | const
| inline

Returns the square of the length(magnitude) of the vector.

Remarks
  This method is for efficiency - calculating the actual length of a vector requires a square root, which is expensive in terms of the operations required. This method returns the square of the length of the vector, i.e. the same as the length but before the square root is taken. Use this if you want to find the longest / shortest vector without incurring the square root.

References x, y, and z.

Referenced by Ogre::Sphere::merge(), perpendicular(), positionCloses(), and Ogre::AxisAlignedBox::squaredDistance().

## ◆ swap()

void Ogre::Vector3::swap | ( | Vector3 & | other | ) |
| inline

Exchange the contents of this vector with another.

References Vector3(), std::swap(), x, y, and z.

## ◆ xy()

Vector2 Ogre::Vector3::xy | ( |  | ) | const
| inline

Swizzle-like narrowing operations.

References x, and y.

## Member Data Documentation

## ◆ NEGATIVE_UNIT_X

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_X
| static

Referenced by primaryAxis().

## ◆ NEGATIVE_UNIT_Y

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_Y
| static

Referenced by primaryAxis().

## ◆ NEGATIVE_UNIT_Z

const Vector3 Ogre::Vector3::NEGATIVE_UNIT_Z
| static

Referenced by Ogre::SceneNode::lookAt(), primaryAxis(), Ogre::SceneNode::setAutoTracking(), Ogre::SceneNode::setDirection(), and Ogre::SceneNode::setDirection().

## ◆ UNIT_SCALE

const Vector3 Ogre::Vector3::UNIT_SCALE
| static

## ◆ UNIT_X

const Vector3 Ogre::Vector3::UNIT_X
| static

Referenced by getRotationTo(), perpendicular(), primaryAxis(), and Ogre::v1::BillboardChain::setFaceCamera().

## ◆ UNIT_Y

const Vector3 Ogre::Vector3::UNIT_Y
| static

Referenced by Ogre::v1::MeshManager::createCurvedIllusionPlane(), Ogre::v1::MeshManager::createCurvedPlane(), Ogre::v1::MeshManager::createPlane(), getRotationTo(), perpendicular(), primaryAxis(), Ogre::Camera::setFixedYawAxis(), and Ogre::SceneNode::setFixedYawAxis().

## ◆ UNIT_Z

const Vector3 Ogre::Vector3::UNIT_Z
| static

Referenced by primaryAxis().

## ◆ x

Real Ogre::Vector3::x

Referenced by Vector3(), Vector3(), Vector3(), Vector3(), Vector3(), absDotProduct(), collapseMax(), collapseMin(), Ogre::AxisAlignedBox::contains(), Ogre::AxisAlignedBox::contains(), crossProduct(), dotProduct(), Ogre::ColourValue::fromVector3(), Ogre::ArrayAabb::getAsAabb(), Ogre::ArrayVector3::getAsVector3(), Ogre::Volume::OctreeNode::getChildrenDimensions(), getRotationTo(), Ogre::Matrix4::getScale(), Ogre::Matrix4::getTrans(), Ogre::AxisAlignedBox::intersection(), Ogre::AxisAlignedBox::intersects(), Ogre::AxisAlignedBox::intersects(), Ogre::Volume::OctreeNode::isBorderLeft(), Ogre::Volume::OctreeNode::isBorderRight(), isNaN(), isZeroLength(), length(), makeAbs(), makeCeil(), makeFloor(), Ogre::Matrix4::makeTrans(), midPoint(), normalise(), operator!=(), Ogre::Matrix4::operator*(), Ogre::Matrix4::operator*(), operator*(), operator*, operator*(), operator*=(), operator*=(), operator+, operator+, operator+(), operator+=(), operator+=(), operator-(), operator-, operator-, operator-(), operator-=(), operator-=(), operator/(), operator/, operator/(), operator/=(), operator/=(), operator<(), operator=(), Ogre::Vector4::operator=(), operator==(), operator>(), operator[](), operator[](), positionEquals(), primaryAxis(), ptr(), ptr(), Ogre::ArraySphere::setAll(), Ogre::ArrayVector3::setAll(), Ogre::AxisAlignedBox::setExtents(), Ogre::ArrayAabb::setFromAabb(), Ogre::ArrayVector3::setFromVector3(), Ogre::Matrix4::setScale(), Ogre::Matrix4::setTrans(), Ogre::AxisAlignedBox::squaredDistance(), squaredLength(), swap(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), Ogre::Matrix4::transformAffine(), Ogre::Matrix4::transformDirectionAffine(), Ogre::AxisAlignedBox::volume(), and xy().

## ◆ y

Real Ogre::Vector3::y

Referenced by Vector3(), Vector3(), Vector3(), Vector3(), Vector3(), absDotProduct(), collapseMax(), collapseMin(), Ogre::AxisAlignedBox::contains(), Ogre::AxisAlignedBox::contains(), crossProduct(), dotProduct(), Ogre::ColourValue::fromVector3(), Ogre::ArrayAabb::getAsAabb(), Ogre::ArrayVector3::getAsVector3(), Ogre::Volume::OctreeNode::getChildrenDimensions(), getRotationTo(), Ogre::Matrix4::getScale(), Ogre::Matrix4::getTrans(), Ogre::AxisAlignedBox::intersection(), Ogre::AxisAlignedBox::intersects(), Ogre::AxisAlignedBox::intersects(), Ogre::Volume::OctreeNode::isBorderBottom(), Ogre::Volume::OctreeNode::isBorderTop(), isNaN(), isZeroLength(), length(), makeAbs(), makeCeil(), makeFloor(), Ogre::Matrix4::makeTrans(), midPoint(), normalise(), operator!=(), Ogre::Matrix4::operator*(), Ogre::Matrix4::operator*(), operator*(), operator*, operator*(), operator*=(), operator*=(), operator+, operator+, operator+(), operator+=(), operator+=(), operator-(), operator-, operator-, operator-(), operator-=(), operator-=(), operator/(), operator/, operator/(), operator/=(), operator/=(), operator<(), operator=(), Ogre::Vector4::operator=(), operator==(), operator>(), positionEquals(), primaryAxis(), Ogre::ArraySphere::setAll(), Ogre::ArrayVector3::setAll(), Ogre::AxisAlignedBox::setExtents(), Ogre::ArrayAabb::setFromAabb(), Ogre::ArrayVector3::setFromVector3(), Ogre::Matrix4::setScale(), Ogre::Matrix4::setTrans(), Ogre::AxisAlignedBox::squaredDistance(), squaredLength(), swap(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), Ogre::Matrix4::transformAffine(), Ogre::Matrix4::transformDirectionAffine(), Ogre::AxisAlignedBox::volume(), and xy().

## ◆ z

Real Ogre::Vector3::z

Referenced by Vector3(), Vector3(), Vector3(), Vector3(), Vector3(), absDotProduct(), collapseMax(), collapseMin(), Ogre::AxisAlignedBox::contains(), Ogre::AxisAlignedBox::contains(), crossProduct(), dotProduct(), Ogre::ColourValue::fromVector3(), Ogre::ArrayAabb::getAsAabb(), Ogre::ArrayVector3::getAsVector3(), Ogre::Volume::OctreeNode::getChildrenDimensions(), getRotationTo(), Ogre::Matrix4::getScale(), Ogre::Matrix4::getTrans(), Ogre::AxisAlignedBox::intersection(), Ogre::AxisAlignedBox::intersects(), Ogre::AxisAlignedBox::intersects(), Ogre::Volume::OctreeNode::isBorderBack(), Ogre::Volume::OctreeNode::isBorderFront(), isNaN(), isZeroLength(), length(), makeAbs(), makeCeil(), makeFloor(), Ogre::Matrix4::makeTrans(), midPoint(), normalise(), operator!=(), Ogre::Matrix4::operator*(), Ogre::Matrix4::operator*(), operator*(), operator*, operator*(), operator*=(), operator*=(), operator+, operator+, operator+(), operator+=(), operator+=(), operator-(), operator-, operator-, operator-(), operator-=(), operator-=(), operator/(), operator/, operator/(), operator/=(), operator/=(), operator<(), operator=(), Ogre::Vector4::operator=(), operator==(), operator>(), positionEquals(), primaryAxis(), Ogre::ArraySphere::setAll(), Ogre::ArrayVector3::setAll(), Ogre::AxisAlignedBox::setExtents(), Ogre::ArrayAabb::setFromAabb(), Ogre::ArrayVector3::setFromVector3(), Ogre::Matrix4::setScale(), Ogre::Matrix4::setTrans(), Ogre::AxisAlignedBox::squaredDistance(), squaredLength(), swap(), Ogre::AxisAlignedBox::transform(), Ogre::AxisAlignedBox::transformAffine(), Ogre::Matrix4::transformAffine(), Ogre::Matrix4::transformDirectionAffine(), and Ogre::AxisAlignedBox::volume().

## ◆ ZERO

const Vector3 Ogre::Vector3::ZERO
| static

Referenced by Ogre::Volume::OctreeNode::OctreeNode(), Ogre::Node::createChild(), Ogre::v1::OldBone::createChild(), Ogre::v1::OldNode::createChild(), Ogre::v1::OldNode::createChild(), Ogre::SceneNode::createChildSceneNode(), Ogre::TagPoint::createChildTagPoint(), Ogre::v1::OldSkeletonInstance::createTagPointOnBone(), Ogre::AxisAlignedBox::getHalfSize(), getRotationTo(), Ogre::AxisAlignedBox::getSize(), Ogre::StringConverter::parseVector3(), randomDeviant(), Ogre::Camera::setAutoTracking(), and Ogre::SceneNode::setAutoTracking().

The documentation for this class was generated from the following file:

- OgreVector3.h